﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace initialD
{
    class Program
    {
        static void Main(string[] args)
        {
            /*
            Original Data before chopping off bytes:
            Track 1:
            FF1452DB7C339EBE9E044F87B31C0FDF3343B8E335DB28219306B111833A9D73FF9F1E370F1C330506133AD2CB5F4B400436D57C0308FC66A13B11CC28E674934F4BE7AD82A5FF8D

            Track 2:
            FFAEA4CC2B5230062A72F7F1C77C0A3724EB2743DA9B2E1DDF8F5B0B70C9D2E86AF7D28D83852DA1590ED1236F21BF76DBD809BF649730BD2185A66F7209CAB79CF45884A443FF6D

            Track 3:
            FFCAA2E28242124ACC3CDBF266D5D956A5D2993320A64C66ABF511CBD617FF3B5B515498CA410EF1B99530506F58268079A3343F4FD4307115A7FCE66FE7E642EF26D2A25715FFE3
            */


            var track1 = "1452DB7C339EBE9E044F87B31C0FDF3343B8E335DB28219306B111833A9D73FF9F1E370F1C330506133AD2CB5F4B400436D57C0308FC66A13B11CC28E674934F4BE7AD82A5";
            var track2 = "AEA4CC2B5230062A72F7F1C77C0A3724EB2743DA9B2E1DDF8F5B0B70C9D2E86AF7D28D83852DA1590ED1236F21BF76DBD809BF649730BD2185A66F7209CAB79CF45884A443";
            var track3 = "CAA2E28242124ACC3CDBF266D5D956A5D2993320A64C66ABF511CBD617FF3B5B515498CA410EF1B99530506F58268079A3343F4FD4307115A7FCE66FE7E642EF26D2A25715";
            
            track1 = ReverseHex(track1,1);
            track2 = ReverseHex(track2,2);
            track3 = ReverseHex(track3,3);

            Console.WriteLine(track1);
            Console.WriteLine(track2);
            Console.WriteLine(track3);
        }

        static string ReverseHex(string hex, int track)
        {
            var final = "";
            var s = HexStringToBinary(hex);
            for (var i = 0; i < s.Length; i += 8)
            {
                var x = s.Substring(i, 8).ToList();
                x.Reverse();
                for (var u = 0; u < 8; u += 1)
                {
                    final += x[u];
                }
            }
            final = BinToHex(final);

            byte[] dBytes = StringToByteArray(final);
            string utf8result = System.Text.Encoding.ASCII.GetString(dBytes);
            //MessageBox.Show(utf8result, "Showing value in UTF8");

            using (var stream = File.Open(@"C:\Users\sdarg\OneDrive\Initial D\track" + track, FileMode.Create))
            {
                using (var writer = new BinaryWriter(stream, Encoding.ASCII, false))
                {
                    writer.Write(utf8result);
                }
            }


            return final;
        }

        private static readonly Dictionary<char, string> hexCharacterToBinary = new Dictionary<char, string> {
            { '0', "0000" },
            { '1', "0001" },
            { '2', "0010" },
            { '3', "0011" },
            { '4', "0100" },
            { '5', "0101" },
            { '6', "0110" },
            { '7', "0111" },
            { '8', "1000" },
            { '9', "1001" },
            { 'a', "1010" },
            { 'b', "1011" },
            { 'c', "1100" },
            { 'd', "1101" },
            { 'e', "1110" },
            { 'f', "1111" }
        };

        public static string HexStringToBinary(string hex)
        {
            StringBuilder result = new StringBuilder();
            foreach (char c in hex)
            {
                // This will crash for non-hex characters. You might want to handle that differently.
                result.Append(hexCharacterToBinary[char.ToLower(c)]);
            }
            return result.ToString();
        }

        static string BinToHex(string bin)
        {
            StringBuilder binary = new StringBuilder(bin);
            bool isNegative = false;
            if (binary[0] == '-')
            {
                isNegative = true;
                binary.Remove(0, 1);
            }

            for (int i = 0, length = binary.Length; i < (4 - length % 4) % 4; i++) //padding leading zeros
            {
                binary.Insert(0, '0');
            }

            StringBuilder hexadecimal = new StringBuilder();
            StringBuilder word = new StringBuilder("0000");
            for (int i = 0; i < binary.Length; i += 4)
            {
                for (int j = i; j < i + 4; j++)
                {
                    word[j % 4] = binary[j];
                }

                switch (word.ToString())
                {
                    case "0000": hexadecimal.Append('0'); break;
                    case "0001": hexadecimal.Append('1'); break;
                    case "0010": hexadecimal.Append('2'); break;
                    case "0011": hexadecimal.Append('3'); break;
                    case "0100": hexadecimal.Append('4'); break;
                    case "0101": hexadecimal.Append('5'); break;
                    case "0110": hexadecimal.Append('6'); break;
                    case "0111": hexadecimal.Append('7'); break;
                    case "1000": hexadecimal.Append('8'); break;
                    case "1001": hexadecimal.Append('9'); break;
                    case "1010": hexadecimal.Append('A'); break;
                    case "1011": hexadecimal.Append('B'); break;
                    case "1100": hexadecimal.Append('C'); break;
                    case "1101": hexadecimal.Append('D'); break;
                    case "1110": hexadecimal.Append('E'); break;
                    case "1111": hexadecimal.Append('F'); break;
                    default:
                        return "Invalid number";
                }
            }

            if (isNegative)
            {
                hexadecimal.Insert(0, '-');
            }

            return hexadecimal.ToString();
        }

        public static byte[] StringToByteArray(String hex)
        {
            int NumberChars = hex.Length / 2;
            byte[] bytes = new byte[NumberChars];
            using (var sr = new StringReader(hex))
            {
                for (int i = 0; i < NumberChars; i++)
                    bytes[i] =
                      Convert.ToByte(new string(new char[2] { (char)sr.Read(), (char)sr.Read() }), 16);
            }
            return bytes;
        }
    }
}
